.model small
.486
.code

        org 100h
debut:
        jmp start

fpu     dw 0
x       dw 50
x_numerateur dw -240
x_denominateur dw 160
y_numerateur dw -100
y_denominateur dw 100
y       dw 50
;mandelbrot
color       db 0
a       dw 0

start:
        mov ax,13h
        int 10h

        call mandelbrot

fin:
        xor ax,ax
        int 16h
        mov ax,04c00h
        int 21h

julia proc near
        finit
        xor ax,ax
        mov x,ax
        mov y,ax

        mov a,ax
        mov color,al

        fild x_numerateur  ;on charge x et y
        fidiv x_denominateur
        fild y_numerateur  ;on charge x et y
        fidiv y_denominateur

boucle_julia:
;        fild a
        fld st(0)
        fmul st(0),st(0)
;        fild b
        fld st(2)
        fmul st(0),st(0)
        fsubp st(1)
        mov a,1
        fild a
        mov a,10
        fidiv a
        faddp st(1)     ;a^2-b^2+x en st(0) - le nouveau a

        fld st(1)       ;a
        fmul st(0),st(3)     ;b
        fadd st(0),st(0)
        mov a,5
        fild a
        mov a,10
        fidiv a
        faddp st(1)     ;2ab+y - le nouveau b

;on calcule le module a^2+b^2
        fld st(0)
        fmul st(0),st(0)     ;b^2
        fxch st(2)
        fld st(0)
        fmul st(0),st(0)     ;a^2
        faddp st(3)     ;a^2+b^2
        fxch st(2)

        fistp fpu
        fxch st(3)
;        fistp b
        fxch st(1)
        fxch st(2)
        fcompp          ;vider le copro
        inc color
        cmp color,50
        je suite_julia
        cmp fpu,4
        jl boucle_julia

        add color,0
        call affichage_pixel
suite_julia:
        finit   ;pour virer les 2 en surplus
        xor dx,dx
        mov a,dx
        mov color,dl
        inc x
        inc x_numerateur
        fild a  ;on charge des 0
        fild a
        cmp x,320
        jne boucle_julia

        mov x,0
        mov x_numerateur,-240
        inc y
        inc y_numerateur
        cmp y,200
        jne boucle_julia

        ret
        endp julia


mandelbrot proc near
        finit
        xor ax,ax
        mov x,ax
        mov y,ax

        mov a,ax
        mov color,al

        fild a  ;on charge des 0
        fild a

boucle_mandelbrot:
;        fild a
        fld st(0)
        fmul st(0),st(0)
;        fild b
        fld st(2)
        fmul st(0),st(0)
        fsubp st(1)
        fild x_numerateur
        fidiv x_denominateur
        faddp st(1)     ;a^2-b^2+x en st(0) - le nouveau a

        fld st(1)       ;a
        fmul st(0),st(3)     ;b
        fadd st(0),st(0)
        fild y_numerateur
        fidiv y_denominateur
        faddp st(1)     ;2ab+y - le nouveau b

;on calcule le module a^2+b^2
        fld st(0)
        fmul st(0),st(0)     ;b^2
        fxch st(2)
        fld st(0)
        fmul st(0),st(0)     ;a^2
        faddp st(3)     ;a^2+b^2
        fxch st(2)

        fistp fpu
        fxch st(3)
;        fistp b
        fxch st(1)
        fxch st(2)
        fcompp          ;vider le copro
        inc color
        cmp color,50
        je suite_mandelbrot
        cmp fpu,4
        jl boucle_mandelbrot

        add color,40
        call affichage_pixel
suite_mandelbrot:
        finit   ;pour virer les 2 en surplus
        xor dx,dx
        mov a,dx
        mov color,dl
        inc x
        inc x_numerateur
        fild a  ;on charge des 0
        fild a
        cmp x,320
        jne boucle_mandelbrot

        mov x,0
        mov x_numerateur,-240
        inc y
        inc y_numerateur
        cmp y,200
        jne boucle_mandelbrot

        ret
        endp mandelbrot


clear proc near
        push bx

        xor si,si
        push 0a000h
        pop es
        mov bl,color
boucle_clear:
        mov es:[si],bl
        inc si
        cmp si,0
        jne boucle_clear
        pop bx
        ret
        endp clear

position_pixel proc near
;position dans un plan 320*200 avec x,y
;position en es:[si]
        push dx
        push 0a000h
        pop es
        mov si,y
        mov dx,si
        shl si,6
        shl dx,8
        add si,dx
        add si,x
        pop dx
        ret
        endp position_pixel

tempo proc near
        push ax
        push bx

        xor ax,ax
        xor bx,bx
boucle_tempo:
        inc ax
        cmp ax,0
        jne boucle_tempo
        xor ax,ax
        inc bx
        cmp bx,02h
        jne boucle_tempo

        pop bx
        pop ax
        ret
        endp tempo

affichage_pixel proc near
;affichage dans un plan 320*200 avec x,y

        call position_pixel

        cmp si,0
        jb fin_affichage_pixel

        mov dl,color
        mov es:[si],dl

fin_affichage_pixel:
        ret
        endp affichage_pixel


      end debut


